/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */

import Domain = require('../base/Domain');
import Twilio = require('./Twilio');
import V1 = require('./trusthub/V1');
import { CustomerProfilesListInstance } from './trusthub/v1/customerProfiles';
import { EndUserListInstance } from './trusthub/v1/endUser';
import { EndUserTypeListInstance } from './trusthub/v1/endUserType';
import { PoliciesListInstance } from './trusthub/v1/policies';
import { SupportingDocumentListInstance } from './trusthub/v1/supportingDocument';
import { SupportingDocumentTypeListInstance } from './trusthub/v1/supportingDocumentType';
import { TrustProductsListInstance } from './trusthub/v1/trustProducts';


declare class Trusthub extends Domain {
  /**
   * Initialize trusthub domain
   *
   * @param twilio - The twilio client
   */
  constructor(twilio: Twilio);

  readonly customerProfiles: CustomerProfilesListInstance;
  readonly endUserTypes: EndUserTypeListInstance;
  readonly endUsers: EndUserListInstance;
  readonly policies: PoliciesListInstance;
  readonly supportingDocumentTypes: SupportingDocumentTypeListInstance;
  readonly supportingDocuments: SupportingDocumentListInstance;
  readonly trustProducts: TrustProductsListInstance;
  readonly v1: V1;
}

export = Trusthub;
